<?php
namespace AngelicaO;

class Settings {

    public function __construct() {

    }

    public static function getRemoteAccess() {
        $configs = DB::query('SELECT * FROM config WHERE name LIKE "%remote_access%"', []);

        $remote_access = array();

        foreach ($configs as $config) {
            $remote_access[$config['name']] = $config['value'];
        }

        return $remote_access;
    }

    public static function setRemoteAccess($data) {

        $old_data = DB::query('SELECT * FROM config WHERE name LIKE "remote_access%"', array());

        $remote_access = array(
            'enabled' => false,
            'site_name' => '',
            'auth_token' => '',
            'subdomain' => ''
        );

        if (!empty($data['enabled'])) {
            $remote_access['enabled'] = $data['enabled'];
        }

        if (!empty($data['site_name'])) {
            $remote_access['site_name'] = $data['site_name'];
        }

        if (!empty($data['auth_token'])) {
            $remote_access['auth_token'] = $data['auth_token'];
        }

        if (!empty($data['subdomain'])) {
            $remote_access['subdomain'] = $data['subdomain'];
        }

        $sql = 'REPLACE INTO config (name, value) VALUES ("remote_access_enabled", ?:[enabled,b]), ("remote_access_site_name", ?:[site_name,s]), ("remote_access_auth_token", ?:[auth_token,s]), ("remote_access_subdomain", ?:[subdomain,s])';

        DB::query($sql, $remote_access);


        //check if any changes were made that require the ngrok process to restart
        $subdomain_changed = true;
        $auth_token_changed = true;
        $enabled_changed = true;
        for ($i = 0; $i < sizeof($old_data); $i++) {
            if ($old_data[$i]['name'] === 'remote_access_subdomain' && $remote_access['subdomain'] == $old_data[$i]['value']) {
                $subdomain_changed = false;
            }

            if ($old_data[$i]['name'] === 'remote_access_auth_token' && $remote_access['auth_token'] == $old_data[$i]['value']) {
                $auth_token_changed = false;
            }

            if ($old_data[$i]['name'] === 'remote_access_enabled' && $remote_access['enabled'] == $old_data[$i]['value']) {
                $enabled_changed = false;
            }

        }
        if ($subdomain_changed || $auth_token_changed || $enabled_changed) {
            self::runNgRok($remote_access);
        }

        return array(
            'status' => 'success'
        );

    }

    public static function initNgRok() {
        $remote_access = self::getRemoteAccess();
        $options = array(
            'enabled' => $remote_access['remote_access_enabled'],
            'auth_token' => $remote_access['remote_access_auth_token'],
            'subdomain' => $remote_access['remote_access_subdomain']
        );

        self::runNgRok($options);

        return array(
            'status' => 'success'
        );
    }

    private static function runNgRok($options) {
        exec("sudo killall ngrok  > /dev/null 2>&1 &");

        if (empty($options['enabled']) || empty($options['auth_token'])) {
            return false;
        }

        if (!is_dir('/root/.ngrok2')) {
            exec('sudo mkdir /root/.ngrok2');
        }
        exec("sudo /var/www/html/angelica-o/api/ngrok/ngrok authtoken " . $options['auth_token'] . "  > /dev/null 2>&1 &");

        if (!empty($options['subdomain'])) {
            exec("sudo nohup /var/www/html/angelica-o/api/ngrok/ngrok http -log stdout -log-level debug -log-format json -subdomain=" . $options['subdomain'] . " 80  > /dev/null 2>&1 &");
        } else {
            exec("sudo nohup /var/www/html/angelica-o/api/ngrok/ngrok http -log stdout -log-level debug -log-format json 80  > /dev/null 2>&1 &");
        }

        //TODO add HTTP Basic auth to this?
    }

}