<?php
//Copyright 2017 MuxLab. All rights reserved.

//v1.0.1
session_start();


require 'vendor/autoload.php';
require 'config.php';
require 'utils.php';

spl_autoload_register(function ($classname) {
    $classname = str_replace('\\', '/', $classname);
    require ("./" . $classname . ".php");
});

$config['displayErrorDetails'] = true;
$config['addContentLengthHeader'] = false;

$app = new \Slim\App(["settings" => $config]);

$app->options('/{routes:.+}', function ($request, $response, $args) {
    return $response;
});

$app->add(function ($req, $res, $next) {
    $response = $next($req, $res);
    return $response
        ->withHeader('Access-Control-Allow-Origin', '*')//TODO this line is breaking on v 1.5.5b!!
        ->withHeader('Access-Control-Allow-Methods', 'GET, POST, PUT, DELETE, OPTIONS')
        ->withHeader('Access-Control-Max-Age', '1000')
        ->withHeader('Access-Control-Allow-Headers', 'x-requested-with, Content-Type, origin, authorization, accept, client-security-token');
});

$app->add(function ($request, $response, $next) {
    $username = $request->getParam('user_name');
    $password = $request->getParam('password');
    \MNC\MNC_API::setAccount($username, $password);

    $response = $next($request, $response);
    return $response;
});

//Routes
$routes = glob("./routes/*.php");
foreach ($routes as $route) {
    include $route;
}

$app->run();