<?php
use \Psr\Http\Message\ServerRequestInterface as Request;
use \Psr\Http\Message\ResponseInterface as Response;

//TODO reorganize the api endpoints to be more consistent and be more RESTful

$app->get('/locations', function (Request $request, Response $response) {
    \AngelicaO\AngelicaO::init();
    $locations = AngelicaO\Locations::getLocations();
    //var_dump($locations);exit(0);
    $response = $response->withJson($locations, 200);
    return $response;
});

$app->get('/locations/{parent_id}', function (Request $request, Response $response, $args) {
    \AngelicaO\AngelicaO::init();
    $locations = AngelicaO\Locations::getLocations($args['parent_id']);
    //var_dump($locations);exit(0);
    $response = $response->withJson($locations, 200);
    return $response;
});

$app->post('/locations', function (Request $request, Response $response) {
    \AngelicaO\AngelicaO::init();
    $data = $request->getParsedBody();
    $location = AngelicaO\Locations::addLocation($data);

    if (!empty($location['status']) && $location['status'] === 'error') {
        $response = $response->withJson($location, 400);
    } else {
        $response = $response->withJson($location, 200);
    }

    return $response;
});

$app->get('/locations/location/{id}', function (Request $request, Response $response, $args) {
    \AngelicaO\AngelicaO::init();
    $data = $request->getParsedBody();
    //return $response->withJson($args, 400);
    $result = AngelicaO\Locations::getLocation($args['id']);

    if (!empty($result['status']) && $result['status'] === 'error') {
        $response = $response->withJson($result, 400);
    } else {
        $response = $response->withJson($result, 200);
    }

    return $response;
});

$app->delete('/locations/{id}', function (Request $request, Response $response, $args) {
    \AngelicaO\AngelicaO::init();
    $data = $request->getParsedBody();
    //return $response->withJson($args, 400);
    $result = AngelicaO\Locations::deleteLocation($args['id']);

    if (!empty($result['status']) && $result['status'] === 'error') {
        $response = $response->withJson($result, 400);
    } else {
        $response = $response->withJson($result, 200);
    }

    return $response;
});

/**
 * DEPRECATED
 */
$app->post('/locations/move', function (Request $request, Response $response) {
    \AngelicaO\AngelicaO::init();
    $data = $request->getParsedBody();

    $result = AngelicaO\Locations::moveLocations($data['subjects'], $data['to']);

    if (!empty($result['status']) && $result['status'] === 'error') {
        $response = $response->withJson($result, 400);
    } else {
        $response = $response->withJson($result, 200);
    }

    return $response;
});

$app->post('/locations/moveChildren', function (Request $request, Response $response) {
    \AngelicaO\AngelicaO::init();
    $data = $request->getParsedBody();

    $result = AngelicaO\Locations::moveChildrenLocations($data['fromParent'], $data['toParent']);

    if (!empty($result['status']) && $result['status'] === 'error') {
        $response = $response->withJson($result, 400);
    } else {
        $response = $response->withJson($result, 200);
    }

    return $response;
});

$app->post('/locations/{id}/rename', function (Request $request, Response $response, $args) {
    \AngelicaO\AngelicaO::init();
    $data = $request->getParsedBody();

    $result = AngelicaO\Locations::renameLocation($args['id'], $data['newName']);

    if (!empty($result['status']) && $result['status'] === 'error') {
        $response = $response->withJson($result, 400);
    } else {
        $response = $response->withJson($result, 200);
    }

    return $response;
});

$app->post('/locations/{id}/setPaletteForLocation', function (Request $request, Response $response, $args) {
    \AngelicaO\AngelicaO::init();
    $data = $request->getParsedBody();

    $result = AngelicaO\Locations::setPalette($args['id'], $data['palette']);

    if (!empty($result['status']) && $result['status'] === 'error') {
        $response = $response->withJson($result, 400);
    } else {
        $response = $response->withJson($result, 200);
    }

    return $response;
});

$app->post('/locations/location/visual-mode/{id}', function (Request $request, Response $response, $args) {
    \AngelicaO\AngelicaO::init();
    $data = $request->getParsedBody();
    $data['id'] = $args['id'];

    $result = AngelicaO\Locations::setVisualMode($data);

    if (!empty($result['status']) && $result['status'] === 'error') {
        $response = $response->withJson($result, 400);
    } else {
        $response = $response->withJson($result, 200);
    }
    return $response;
});

$app->post('/locations/{id}/addDevice', function (Request $request, Response $response, $args) {
    \AngelicaO\AngelicaO::init();
    $data = $request->getParsedBody();

    $result = AngelicaO\Locations::addDevice($args['id'], $data['mac']);

    if (!empty($result['status']) && $result['status'] === 'error') {
        $response = $response->withJson($result, 400);
    } else {
        $response = $response->withJson($result, 200);
    }

    return $response;
});

$app->post('/locations/{id}/addDevices', function (Request $request, Response $response, $args) {
    \AngelicaO\AngelicaO::init();
    $data = $request->getParsedBody();

    $result = AngelicaO\Locations::addDevices($args['id'], $data['devices']);

    if (!empty($result['status']) && $result['status'] === 'error') {
        $response = $response->withJson($result, 400);
    } else {
        $response = $response->withJson($result, 200);
    }

    return $response;
});

$app->get('/locations/location/{id}/devices', function (Request $request, Response $response, $args) {
    \AngelicaO\AngelicaO::init();
    $data = $request->getParsedBody();

    $result = AngelicaO\Locations::getDevices($args['id']);

    if (!empty($result['status']) && $result['status'] === 'error') {
        $response = $response->withJson($result, 400);
    } else {
        $response = $response->withJson($result, 200);
    }

    return $response;
});

$app->post('/locations/{id}/saveVisualModeData', function (Request $request, Response $response, $args) {
    \AngelicaO\AngelicaO::init();
    $data = $request->getParsedBody();

    $result = AngelicaO\Locations::saveVisualModeData($args['id'], $data);

    if (!empty($result['status']) && $result['status'] === 'error') {
        $response = $response->withJson($result, 400);
    } else {
        $response = $response->withJson($result, 200);
    }

    return $response;
});

$app->get('/locations/{location_id}/sourcesAvailable', function (Request $request, Response $response, $args) {
    \AngelicaO\AngelicaO::init();

    $result = AngelicaO\Locations::getSourcesAvailable($args['location_id']);

    if (!empty($result['status']) && $result['status'] === 'error') {
        $response = $response->withJson($result, 400);
    } else {
        $response = $response->withJson($result, 200);
    }

    return $response;
});

$app->post('/locations/{id}/setPreferredSources', function (Request $request, Response $response, $args) {
    \AngelicaO\AngelicaO::init();
    $data = $request->getParsedBody();

    $result = AngelicaO\Locations::setPreferredSources($args['id'], $data['sources']);

    if (!empty($result['status']) && $result['status'] === 'error') {
        $response = $response->withJson($result, 400);
    } else {
        $response = $response->withJson($result, 200);
    }

    return $response;
});


$app->get('/locations/{location_id}/navigation', function (Request $request, Response $response, $args) {
    \AngelicaO\AngelicaO::init();

    $result = AngelicaO\Locations::getNavigation($args['location_id']);

    if (!empty($result['status']) && $result['status'] === 'error') {
        $response = $response->withJson($result, 400);
    } else {
        $response = $response->withJson($result, 200);
    }

    return $response;
});