<?php
use \Psr\Http\Message\ServerRequestInterface as Request;
use \Psr\Http\Message\ResponseInterface as Response;


$app->get('/devices/getMultiview/{mac}', function (Request $request, Response $response, $args) {
    \AngelicaO\AngelicaO::init();

    $result = AngelicaO\MultiView::getMultiview($args['mac'], null);

    if (!empty($result['status']) && $result['status'] === 'error') {
        $response = $response->withJson($result, 400);
    } else {
        $response = $response->withJson($result, 200);
    }

    return $response;
});

$app->post('/devices/{mac}/setSelectedMultiviewConfig', function (Request $request, Response $response, $args) {
    \AngelicaO\AngelicaO::init();
    $data = $request->getParsedBody();

    $result = AngelicaO\MultiView::setSelectedConfig($args['mac'], $data['config_id']);

    if (!empty($result['status']) && $result['status'] === 'error') {
        $response = $response->withJson($result, 400);
    } else {
        $response = $response->withJson($result, 200);
    }

    return $response;
});

/**
 * Used to store specific connections made in a video wall after a layout is selected. This is used to show the user what's currently
 * playing when he opens the video wall page. The 811 can give us the connectedMac for each device, but we'd be required to guess which is the active layout,
 * which isn't necessarily possible given that specific connections can be made after a layout is selected
 */
$app->post('/devices/{mac}/setMultiviewSpecificConnections', function (Request $request, Response $response, $args) {
    \AngelicaO\AngelicaO::init();
    $data = $request->getParsedBody();

    $result = AngelicaO\MultiView::setSpecificConnections($args['mac'], (!empty($data['connections'])) ? $data['connections'] : array());

    if (!empty($result['status']) && $result['status'] === 'error') {
        $response = $response->withJson($result, 400);
    } else {
        $response = $response->withJson($result, 200);
    }

    return $response;
});